//-----------------------------------------------------------------------------
// name: raka-entity.h
// desc: entities for visualization
//
// author: Ge Wang (ge@ccrma.stanford.edu)
//   date: 2013
//-----------------------------------------------------------------------------
#ifndef __W_ENTITY_H__
#define __W_ENTITY_H__

#include "y-entity.h"
#include "x-buffer.h"
#include <vector>




//-----------------------------------------------------------------------------
// name: class Spark
// desc: ...
//-----------------------------------------------------------------------------
class Spark : public YEntity
{
public:
    // constructor
    Spark() : texture(0), ALPHA( 1, 1, 1 ) { }
    
public:
    // set
    void set( int _texture, float _size, float _alpha );
    void setTexture( int _texture );
    void setSize( float _size );
    
public:
    // update
    void update( YTimeInterval dt );
    // render
    void render();
    
public:
    // which ripple texture
    GLuint texture;
    // vertices
    GLfloat vertices[8];
    // alpha ramp
    Vector3D ALPHA;
};



#endif
