#include "globals.h"


// defaults
#define DEFAULT_FULLSCREEN    TRUE
#define DEFAULT_WINDOW_WIDTH  1200
#define DEFAULT_WINDOW_HEIGHT 960
#define DEFAULT_BLENDSCREEN   FALSE
#define DEFAULT_VERSION       "1.0.0"

Sim * Globals::sim = NULL;

Words * Globals::wordList = NULL;
string Globals::wordFile = "./data/words/words.txt";
string Globals::tempFile = "./data/temp";

string Globals::pcaFile = "./data/pcaParams.txt";
string Globals::pastFreqsFile = "./data/pastFreqs.txt";

Pane * Globals::controlPanel = NULL;

// pane
Vector3D Globals::txtEnterWordPos = Vector3D(-.9,-.8,0);
Vector3D Globals::txtRatePos = Vector3D(0,-.8,0);
Vector3D Globals::txtSimilarWordsPos = Vector3D(-.9,-.9,0);
Vector3D Globals::txtRatingPos = Vector3D(.4,-.8,0);

Vector3D Globals::txtEnterWordCol = Vector3D(1,1,1);
Vector3D Globals::txtRateCol = Vector3D(1,1,1);
Vector3D Globals::txtSimilarWordsCol = Vector3D(1,1,1);
Vector3D Globals::txtRatingCol = Vector3D(1,.94,.36);

Vector3D Globals::raterLineStart = Vector3D(.1,-.83,0);
Vector3D Globals::raterLineEnd = Vector3D(.9,-.83,0);

Vector3D Globals::raterLineColor = Vector3D(1,1,1);
Vector3D Globals::raterCircleColor = Vector3D(.68,.68,.93);
float Globals::raterCircleRadius = .02;

Vector3D Globals::wordBoxCorner1 = Vector3D(-.9,-.81,0);
Vector3D Globals::wordBoxCorner2 = Vector3D(-.1,-.85,0);
Vector3D Globals::wordsBoxCorner1 = Vector3D(-.9,-.91,0);
Vector3D Globals::wordsBoxCorner2 = Vector3D(.9,-.95,0);

int Globals::interactionMode = 0;

wsWord * Globals::focalWord = NULL;
wsWord * Globals::ringingWord = NULL;
Vector3D * Globals::focalWordTrans = new Vector3D(0,0,0);

// window
GLsizei Globals::windowWidth = DEFAULT_WINDOW_WIDTH;
GLsizei Globals::windowHeight = DEFAULT_WINDOW_HEIGHT;
GLsizei Globals::lastWindowWidth = Globals::windowWidth;
GLsizei Globals::lastWindowHeight = Globals::windowHeight;

GLboolean Globals::fullscreen = DEFAULT_FULLSCREEN;
GLboolean Globals::blendScreen = DEFAULT_BLENDSCREEN;

Vector3D Globals::blendAlpha( 1, 1, .5f );
GLfloat Globals::blendRed = 0.0f;
GLenum Globals::fillmode = GL_FILL;
iSlew3D Globals::bgColor( .5 );
Vector3D Globals::viewRadius( 5, 2, 1 );
Vector3D Globals::viewEyeY( 2, 0, 1.5f );
Vector3D Globals::viewEyeX( 0, 0, 1.5f );
Vector3D Globals::fov( 80, 100, .2f );
Vector3D Globals::viewX(0,0,VIEW_SLEWRATE);
Vector3D Globals::viewY(0,0,VIEW_SLEWRATE);
Vector3D Globals::viewZ(0,0,VIEW_SLEWRATE);

// midi
RtMidiIn * Globals::midiIn = NULL;

// audio
RtAudio * Globals::audioIO = NULL;
RtAudio::StreamOptions * Globals::ioStreamOptions = NULL;
RtAudio::StreamParameters * Globals::iStreamParams = NULL;
RtAudio::StreamParameters * Globals::oStreamParams = NULL;

unsigned int Globals::bufferBytes = 0;
unsigned int Globals::bufferFrames = FRAMESIZE;

// synthesizer
vector<wsSynth *> Globals::synth = *new vector<wsSynth *>(NNOTES);
int * Globals::synthNote = new int[NNOTES];
int Globals::synthInd = 0;

int Globals::inPlay = 0;

GLfloat * Globals::pastFreqs = new GLfloat[NPASTFREQS];
int Globals::pastFreqsInd = 0;
int Globals::isRinging = 0;
GLfloat Globals::timeSinceLastRing = 0;

GLfloat Globals::light0_pos[4] = { 2.0f, 1.2f, 4.0f, 1.0f };
GLfloat Globals::light1_ambient[4] = { .2f, .2f, .2f, 1.0f };
GLfloat Globals::light1_diffuse[4] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat Globals::light1_specular[4] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat Globals::light1_pos[4] = { -2.0f, 0.0f, -4.0f, 1.0f };

std::string Globals::version = DEFAULT_VERSION;

// time
GLfloat Globals::timeSinceLastR = 0;
int Globals::hasExploded = 2;
GLfloat Globals::timeSinceLastInteraction = 0;
GLfloat Globals::eighthNoteTempo = 60;
GLfloat Globals::noteDuration = 0;
GLfloat Globals::noteDurationHold = 0;
GLfloat Globals::noteDurationHoldTypical = 4;