#include "midi.h"
#include <iostream>

void wsMidi::initialize( void (* midiInCallback) ( double, vector< unsigned char > *, void *) ){

    string portName;        // midi port name
    int iMidiIn = 0;        // midi input port number
    
    cerr << "create new midi object ..." << endl;
    
    // create new midi in object
    try {
        midiIn = new RtMidiIn();
    }
    catch (RtError &error){
        error.printMessage();
    }
    
    cerr << "check inputs" << endl;
    
    // check inputs
    unsigned int nPorts = midiIn->getPortCount();
    // exit if no ports are available
    if (nPorts==0){
        cout << "No ports available! : (" << endl;
    }
    else{
        // list input ports
        cout << "\n";
        for (unsigned int i=0; i<nPorts; i++){
            try{
                portName = midiIn->getPortName(i);
            }
            catch( RtError &error){
                error.printMessage();
            }
            cout << i+1 << ": " << portName << endl;
        }
        // get user to select input
        cout << "Please select 1 of " << nPorts << " MIDI input source[s].\n";
        cin >> iMidiIn;
        // open port
        midiIn->openPort(iMidiIn-1);
        // set callback
        midiIn->setCallback( midiInCallback );
        // don't ginore syex, timing, or active sensing messages
        midiIn->ignoreTypes(false,false,false);
    }

}