#ifndef __W_SIM_H__
#define __W_SIM_H__

#include "words.h"

//-----------------------------------------------------------------------------
// name: class Sim
// desc: simulation class
//-----------------------------------------------------------------------------
class Sim
{
    
// constructor/destructor
public:
    Sim();
    virtual ~Sim();
    
public:
    // cascade timestep simulation through system (as connected to this)
    void systemCascade();
    
public:
    // pause the simulation
    void pause();
    // resume the simulation
    void resume();
    // get is paused
    bool isPaused() const;
    
public:
    // set desired frame rate
    void setDesiredFrameRate( double frate );
    // get it
    double getDesiredFrameRate() const;
    // get the timestep in effect (fixed or dynamic)
    YTimeInterval delta() const;
    
public:
    // get the root
    YEntity & root() { return m_gfxRoot; }
    YEntity & root2D() { return m_2dRoot; }
    
protected:
    YEntity m_gfxRoot;
    YEntity m_2dRoot;
public:
    double m_desiredFrameRate;
    bool m_useFixedTimeStep;
    
public:
    YTimeInterval m_timeLeftOver;
    YTimeInterval m_simTime;
    YTimeInterval m_lastDelta;
    bool m_first;
    bool m_isPaused;
};

#endif
